/**
* Diese Klasse kann ein Integer-Array nach dem MergeSort-Verfahren sortieren.
*
* @author Mirko Mumberg
* @version 1.0  date : 07.06.1997 
*/
public class CMergesortAlg extends CSortAlg
{
	/**
	* Mischt das Array von l bis r auseinander und wieder zusammen.
	* @param a Das zusortierende Array.
	* @param l Anfangsposition im Array.
	* @param m Mitteposition im Array.
	* @param r Endposition im Array
	*/
	public void Merge(CArray a, int l, int m, int r)
	{
		CArray tmp = new CArray(a.getSize(), null, null);
		int i = l;
		int j = m + 1;
		int k = l;
		int h;

		while (CompareLower(i,  m+1) && CompareLower(j, r+1))
		{
			if (CompareLower(a.Get(i), a.Get(j)+1))
			{
				tmp.Set(k, a.Get(i));
				i++;
			}
			else
			{
				tmp.Set(k, a.Get(j));
				j++;
			}
			k++;
		}
		if (CompareLower(m,i))
		{
			for (h = j; CompareLower(h,r+1); h++)
			{
				tmp.Set((k + h - j), a.Get(h));
			}
		}
		else
		{
			for (h = i;CompareLower(h, m+1); h++)
			{
				tmp.Set((k + h - i), a.Get(h));
			}
		}

		for ( h = l;CompareLower(h, r+1); h++)
		{
			a.Set(h, tmp.Get(h));
			paint();
		}
	}

	/**
	* Fuehrt den Mergesort-Algorithmuss im Array von l bis r durch.
	* @param a Das zusortierende Array.
	* @param l Anfangsposition im Array.
	* @param r Endposition im Array
	*/
	public void MergeSort(CArray a, int l, int r)
	{
		if (CompareLower(l, r))
		{
			int m = (l + r) / 2;
			MergeSort(a,l,m);
			MergeSort(a,(m+1),r);
			Merge(a,l,m,r);
		}
	}

	/**
	* Ruft die MergeSort-Methode auf.
	* @param a Das zusortierende Array.
	*/
	public void Sort(CArray a)
	{
		MergeSort(a, 0, (a.getSize() - 1));
	}
}

