/**
* CPixelSizeChoice ist ein CStepChoice , der in einen CSortCanvas und in einem CSortFrame die Groesse der Quadrate einstellt.
*
* @author Mirko Mumberg
* @version 1.0  date : 07.06.1997 
* @see CSortCanvas
* @see CSortFrame
*/
public class CPixelSizeChoice extends CStepChoice
{
	/**
	* SizeCanvas ist das CSortCanvas, in dem die Groesse eingestellt werden soll.
	*/
	protected CSortCanvas m_SizeCanvas;
	/**
	* SizeFrame ist das CSortFrame, dessen Greosse veraendert werden soll.
	*/
	protected CSortFrame  m_SizeFrame;

	/**
	* Der Konstruktor ruft lediglich den Konstruktor von CStepChoice auf und initialisiert den CSortCanvas und den CSortFrame .
	* @param SFrame Ist der CSortFrame, indem die Groesse geaendert werden soll.
	* @param SCanvas Ist der CSortCanvas, indem die Groesse geaendert werden soll. 
	* @param _Begin Ist der unterste Wert im Choice
	* @param _End Ist der oberste Wert im Choice
	* @param _Step Ist die Schrittgroesse zwischen den Werten im Choice
	* @param _Default Ist das Defaultelement. Es enthaelt die Position des Defaultelements. Begonnen wird mit 0 fuer das Beginelement.
	* @param _Label Ist der String der an den Wert angehaengt wird. 
	*/
	public CPixelSizeChoice(CSortFrame _SFrame, CSortCanvas _SCanvas, int _Begin, int _End, int _Step, int _Default, String _Label)
	{
		super( _Begin, _End, _Step, _Default, _Label);
		m_SizeFrame = _SFrame;
		m_SizeCanvas = _SCanvas;
	}
	
	/**
	* Ruft die setElementSize-Methode in einem CSortCanvas und  in einem CSortFrame auf.
	* @param Value Der Wert, der im CSizeChoice ausgewaehlt wurde.
	*/
	public void doAction(int Value)
	{
		m_SizeFrame.setElementSize(Value);
		m_SizeCanvas.setElementSize(Value);
	}
}

