//******************************************************************************
// Vektoren.java:	Beispielanwendung fr die (Interface-)Klassen RotationEngine
//					und VectorObject
//
// Author:  Sven Sa 
// am:		20/05/97
// Besch.:  Zeigt einige einfache Vektorobjekte an und rotiert diese
//******************************************************************************

import java.applet.*;
import java.awt.*;
import java.util.Random;

import Satellite;		// a satellite world

public class Vektoren extends Applet implements Runnable
{
	//- Variablen ---------------------------------------------------------------
	private int		appHeight	=640;
	private int		appWidth	=400;
	private Thread	m_Vektoren	= null;

	//-- The Vector Worlds ------------------------------------------------------	
	private Satellite sat;	 // = 0

	private int world =1;	// switch fr welche welt

	//-- Double Buffering -------------------------------------------------------
	private int imgWidth	=639;		// Breite des Images
	private int imgHeight	=399;		// Hhe des Images

	private Image myImage;				// Image fr
	private Graphics myGraphic;			// diese Grafik

	

	//-- Informational ----------------------------------------------------------
	private int FrameCnt=0,FrameCnt2=0;		// Anzahl Frames
	long FPS;
	long startTime=-1;

	String itext = "Vector Engine";
	String itext2;

	// - Fonts ------------------------------------------------------------------
	Font infoFont = new Font ("Arial",Font.PLAIN, 16);
	Font demoFont = new Font ("New Times Roman",(Font.ITALIC | Font.BOLD), 25);


	//--------------------------------------------------------------------------
	public Vektoren()
	{
	}

	//--------------------------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: Vektoren\r\n" + "Author: Sven Sass\r\n";
	}

    //--------------------------------------------------------------------------
	public void init()
	{
 		resize(appHeight, appWidth);
		myImage =createImage (imgWidth,imgHeight);	// Bild erstellen
		myGraphic = myImage.getGraphics();			// Grafik holen

		world = Integer.valueOf (getParameter("mainsw")).intValue();
		switch (world)
		{
			default:
			case 0:	sat = new Satellite(); itext2="Satellites"; break;		// a satellite world
			case 1:	sat = new Satellite(1,0,false);itext2="OneFace";break;	// one face
			case 2:	sat = new Satellite(4,0,false);itext2="OneCube";break;	// one cube
			case 3: sat = new Satellite(2,0,false);itext2="OnePyramid";break;	// one pyramid
			case 4: sat = new Satellite(3,0,false);itext2="OneBall";break;	// one ball
			case 5: sat = new Satellite(3,0,true); itext2="Rotating Light";break;	// rotating light
			case 6: sat = new Satellite(5,0,true); itext2="Hornet Attack";break;	// hornet
		}
		
		startTime=System.currentTimeMillis()/1000;

	}

	//-------------------------------------------------------------------------
	public void  destroy()
	{
	}

	//--------------------------------------------------------------------------
	public void paint(Graphics g)
	{
	}

	//--------------------------------------------------------------------------
	public void start()
	{
		if (m_Vektoren == null)
		{
			m_Vektoren = new Thread(this);
			m_Vektoren.start();
		}
		// TODO: Place additional applet start code here
	}
	
	//		The stop() method is called when the page containing the applet is
	// no longer on the screen. The AppletWizard's initial implementation of
	// this method stops execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void stop()
	{
		if (m_Vektoren != null)
		{
			m_Vektoren.stop();
			m_Vektoren = null;
		}
		// TODO: Place additional applet stop code here
	}

	//--------------------------------------------------------------------------
	public void run() 
	{
		while (true)
		{
			try
			{
				zeichnen();			// das aktuelle Bild zeichnen
				Thread.sleep(5);
			}
			catch (InterruptedException e)
			{
				// TODO: Place exception-handling code here in case an
				//       InterruptedException is thrown by Thread.sleep(),
				//		 meaning that another thread has interrupted this one
				stop();
			}
		}
	}

	//- Applet Routinen --------------------------------------------------------
	
   	public void zeichnen ()
	{	
		if (FrameCnt>60) FPS = FrameCnt / (  (System.currentTimeMillis()/1000) - startTime   );
				  else   FPS = 0;


		myGraphic.setColor(Color.black);				// Bild zurcksetzen
		myGraphic.fillRect(0,0,imgWidth,imgHeight);
				
		int faces = 0, totfaces=0;

		switch (world)
		{
			default:
			case 0:
					{
						faces = sat.getVisibleCount();
						totfaces = sat.itemCount();
						sat.draw(myGraphic);
					}
		}


		myGraphic.setColor(Color.white);myGraphic.setFont (infoFont);
		myGraphic.drawString ("Faces(vis):",0,16);myGraphic.drawString (Integer.toString(faces),90,16);
		myGraphic.drawString ("Faces(tot):",0,32);myGraphic.drawString (Integer.toString(totfaces),90,32);
		myGraphic.drawString ("Frame:",0,48);myGraphic.drawString (Integer.toString(FrameCnt++),90,48);
		myGraphic.drawString ("FPS  :",0,64);myGraphic.drawString (Integer.toString((int)FPS),90,64);

		myGraphic.setFont (demoFont);myGraphic.setColor(Color.red);
		myGraphic.drawString (itext+ "(" + itext2 + ")",150,380);
		if (getGraphics()!=null)getGraphics().drawImage (myImage,0,0,Color.black,this);
	}
} // class Vektoren
