import java.io.*;
import java.net.*;
import java.awt.*;

public class MouseBallFrame extends BallFrame {
	protected PrintWriter out;			// Ausgabestream
	protected int mx = 0, my = 0;			// Koordinaten des letzten Mausklicks

	public MouseBallFrame(Socket socket, String name) {
		super(name);
		try {					// Ausgabestream erzeugen
			out = new PrintWriter(socket.getOutputStream());
		}
		catch (IOException e) {
			System.err.println("Ausnahme beim Bereitstellen der Socketstreams: " + e);
		}
	}

	public void send(String line) {
		if (out != null) {				// Wenn Ausgabestream aktiv
			out.println(line);			// Daten an Client ausgeben
			out.flush();				// und sofort senden
		}
	}

	public void sendAbs(int x, int y) {
		send("abs " + x + " " + y);			// Daten an Client ausgeben
	}

	public void sendRel(int x, int y) {
		send("rel " + x + " " + y);			// Daten an Client ausgeben
	}

	public boolean mouseDown(Event e, int x, int y) {
		sendAbs((mx = x - ux), (my = uy - y));
		return true;
	}

	public boolean mouseDrag(Event e, int x, int y) {
		sendRel(-mx + (mx = x - ux), -my + (my = uy - y));
		return true;
	}

	public void finalize() {
		out.close();					// Ausgabestream schlieen
	}
}
